package de.incircuit.demo.gpio;

import de.incircuit.hw.CNT;
import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.View;
import android.widget.EditText;

public class cntActivity extends Activity {
	private static final String TAG = "adcActivity.java";
	private static final boolean DEBUG = false;
	private static final int CNT_TIMER_TIMEOUT = 1000;
	private Handler mHandler = new Handler();
	private CNT counter[] = { new CNT(0), new CNT(1), new CNT(2), new CNT(3), new CNT(4) };
	private Runnable cntTimerTask = new Runnable() {
		// @Override
		public void run() {
			refresh_status();
			mHandler.postDelayed(this, CNT_TIMER_TIMEOUT);
		}
	};
	
	private void refresh_counter(int id, int valid, int tickid, int resid) {
		EditText field;
		int kwhTicks;
		int ticks = counter[id].get();
		field = (EditText) findViewById(valid);
		field.setText(ticks+"");
		field = (EditText) findViewById(tickid);
		try {
			kwhTicks = Integer.parseInt(field.getText().toString());
			ticks *= 1000;
			ticks /= kwhTicks;
		} catch (Exception e) {
		}
		field = (EditText) findViewById(resid);
		field.setText(String.format("%d,%03dkWh", ticks/1000, ticks % 1000));		
	}
	
	protected void refresh_status() {
		refresh_counter(0, R.id.CntVal01, R.id.CntTicks01, R.id.CntRes01);
		refresh_counter(1, R.id.CntVal02, R.id.CntTicks02, R.id.CntRes02);
		refresh_counter(2, R.id.CntVal03, R.id.CntTicks03, R.id.CntRes03);
		refresh_counter(3, R.id.CntVal04, R.id.CntTicks04, R.id.CntRes04);
		refresh_counter(4, R.id.CntVal05, R.id.CntTicks05, R.id.CntRes05);
	}
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		if(DEBUG)
			Log.d(TAG, "Creating CounterActivity");
		super.onCreate(savedInstanceState);
		setContentView(R.layout.cnt);
	}

	public void onPause() {
		mHandler.removeCallbacks(cntTimerTask);
		super.onPause();
	}

	public void onResume() {
		super.onResume();
		mHandler.removeCallbacks(cntTimerTask);
		mHandler.postDelayed(cntTimerTask, 1);
	}
	
	public void onRst1(View view) {
		counter[0].reset();
	}
	public void onRst2(View view) {
		counter[1].reset();
	}
	public void onRst3(View view) {
		counter[2].reset();
	}
	public void onRst4(View view) {
		counter[3].reset();
	}
	public void onRst5(View view) {
		counter[4].reset();
	}
}
