package de.incircuit.demo.gpio;

import de.incircuit.hw.GPIO;
import android.app.Dialog;
import android.app.ListActivity;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CheckedTextView;
import android.widget.ListView;
import android.widget.RadioButton;

public class gpioActivity extends ListActivity {
	private static final String TAG = "gpioActivity.java";
	private static final boolean DEBUG = false;

	private static final int MAX_ITEMS = 33;
	private String[] listItems = new String[MAX_ITEMS];
	private GPIO[]	gpio = new GPIO[MAX_ITEMS];
	
	private final int GPIO_TIMER_TIMEOUT = 400;
	private Handler mHandler = new Handler();
	private Runnable gpioTimerTask = new Runnable() {
		// @Override
		public void run() {
			refresh_status();
			mHandler.postDelayed(this, GPIO_TIMER_TIMEOUT);
		}

	};
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.gpio);
		if(DEBUG)
			Log.d(TAG, "Creating gpioActivity");

        int a = 0;
        listItems[a++] = "PC"+10;
        listItems[a++] = "PC"+15;
        listItems[a++] = "PC"+17;
        listItems[a++] = "PC"+18;
        listItems[a++] = "PC"+19;
        listItems[a++] = "PC"+20;
        listItems[a++] = "PC"+21;
        listItems[a++] = "PC"+22;
        listItems[a++] = "PC"+23;
        listItems[a++] = "PC"+24;
        listItems[a++] = "PC"+25;
        listItems[a++] = "PC"+26;
        listItems[a++] = "PC"+27;
        listItems[a++] = "PC"+28;
        listItems[a++] = "PD"+04;
        listItems[a++] = "PD"+10;
        listItems[a++] = "PD"+11;
        listItems[a++] = "PD"+12;
        listItems[a++] = "PD"+13;
        listItems[a++] = "PD"+14;
        listItems[a++] = "PD"+15;
        listItems[a++] = "PD"+19;
        listItems[a++] = "PD"+20;
        listItems[a++] = "PD"+21;
        listItems[a++] = "PD"+22;
        listItems[a++] = "PD"+24;
        listItems[a++] = "PD"+25;
        listItems[a++] = "PD"+26;
        listItems[a++] = "PD"+27;
        listItems[a++] = "PD"+28;
        listItems[a++] = "PD"+29;
        listItems[a++] = "PD"+30;
        listItems[a++] = "PD"+31;
        
        for(int i = 0; i < MAX_ITEMS; i++){
        	gpio[i] = new GPIO(listItems[i]);
        }
        
        setListAdapter(new ArrayAdapter<String>(this, android.R.layout.simple_list_item_single_choice, listItems));
        //setListAdapter(new ArrayAdapter<String>(this, R.layout.klavier, listItems));	
    }
    
    public void onPause(){
        mHandler.removeCallbacks(gpioTimerTask);
    	super.onPause();
    }
    
    public void onResume(){
    	super.onResume();
        mHandler.removeCallbacks(gpioTimerTask);
		mHandler.postDelayed(gpioTimerTask, 1);
    }
    
    private void refresh_status(){
    	ListView lv = (ListView) this.getListView();
    	lv.setChoiceMode(ListView.CHOICE_MODE_MULTIPLE);
    	
    	for(int i = 0; i < MAX_ITEMS; i++){
    		lv.setItemChecked(i, gpio[i].getValue() == 0 ? false: true);
    	}
    }
    
    @Override
    protected void onListItemClick(ListView l, View v, int position, long id) {
    	CheckedTextView ctv = (CheckedTextView) v;
    	final Dialog dialog = new Dialog(this);
    	Log.d("GPIO", ctv.toString());
		dialog.setContentView(R.layout.gpio_setup);
		dialog.setTitle("Setup "+ ctv.getText());
		
		final int pos = position;
		Button button;
		button = (Button) dialog.findViewById(R.id.ButtonOK);
		button.setOnClickListener(new OnClickListener() {
			// @Override
			public void onClick(View v){
				RadioButton radio;
				radio = (RadioButton) dialog.findViewById(R.id.RadioButtonInput);
				if(radio.isChecked()){
					gpio[pos].setDirection("in");
				}else{
					gpio[pos].setDirection("out");
				}
				
				radio = (RadioButton) dialog.findViewById(R.id.RadioButtonLow);
				if(radio.isChecked()){
					gpio[pos].setValue(0);
				}else{
					gpio[pos].setValue(1);
				}
				refresh_status();
				
				dialog.cancel();
			}
		});
		
		RadioButton radio;
		if(gpio[position].getDirection().contains("out")){
			radio = (RadioButton) dialog.findViewById(R.id.RadioButtonInput);
			radio.setChecked(false);
			radio = (RadioButton) dialog.findViewById(R.id.RadioButtonOutput);
			radio.setChecked(true);
		}
		else{
			radio = (RadioButton) dialog.findViewById(R.id.RadioButtonInput);
			radio.setChecked(true);
			radio = (RadioButton) dialog.findViewById(R.id.RadioButtonOutput);
			radio.setChecked(false);
		}
		
		if(gpio[position].getValue() == 0){
			radio = (RadioButton) dialog.findViewById(R.id.RadioButtonHigh);
			radio.setChecked(false);
			radio = (RadioButton) dialog.findViewById(R.id.RadioButtonLow);
			radio.setChecked(true);
		}
		else{
			radio = (RadioButton) dialog.findViewById(R.id.RadioButtonHigh);
			radio.setChecked(true);
			radio = (RadioButton) dialog.findViewById(R.id.RadioButtonLow);
			radio.setChecked(false);
		}
		
		dialog.show();
		refresh_status();
    }
}

