package de.incircuit.demo.gpio;

import android.app.Activity;
import android.os.Bundle;
import android.util.Log;
import android.view.MotionEvent;
import android.view.View;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.TextView;
import de.incircuit.hw.Buzzer;

public class klavierActivity extends Activity {
	private static final String TAG = "klavierActivity.java";
	private static final int BUZZER_OFF = 0;
	private static final boolean use_layout_buttons = false;
	private Buzzer buzz = new Buzzer();
	private static final int freqs[] = {
		261, 293, 329, 349, 391, 440, 493, 523,
	};

	protected class noteListener implements View.OnTouchListener {
		private int freq;

		public noteListener(int freq) {
			super();
			this.freq = freq;
		}

		public boolean onTouch(View v, MotionEvent event) {
			switch(event.getAction()){
			case MotionEvent.ACTION_DOWN:
				Log.d(TAG, "buzzer @"+freq+"Hz");
		        buzz.setBuzzer(freq);
				break;
			case MotionEvent.ACTION_UP:
		        buzz.setBuzzer(BUZZER_OFF);
				break;
			}
			return false;
		}

	}

	private void setBuzzerFreq(View btn, int freq) {
		Button buzzer = (Button) btn;
		buzzer.setOnTouchListener(new noteListener(freq));
	}

	/** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
	super.onCreate(savedInstanceState);
	setContentView(R.layout.klavier);

	TextView desc = (TextView) findViewById(R.id.Description);
	desc.setText("The buzzer is stimulated by a given frequency.\n" +
		"To start the process of Stimulation this frequency shloud be written to the file " +
		"/sys/bus/spi/devices/spi0.0/buzzer. Writing a 0 here, will stop the buzzer again.\n" +
		"Altenativly, the buzzer can be set up by the method setBuzzer(int freq) of a object with" +
		"class de.incircuit.hw.Buzzer");
	buzz.setBuzzer(BUZZER_OFF);

	int nfreqs = freqs.length;
	LinearLayout buzzerPlane = (LinearLayout) findViewById(R.id.Buzzers);
	if(use_layout_buttons) {
		if(nfreqs > buzzerPlane.getChildCount()) nfreqs = buzzerPlane.getChildCount();
	}
	for(int i = 0; i<nfreqs; i++) {
		View Btn;
		if(use_layout_buttons) {
			Btn = buzzerPlane.getChildAt(i);
		} else {
			Button bttn = new Button(this.getBaseContext());
			bttn.setWidth(80);
			bttn.setHeight(200);
			buzzerPlane.addView(bttn);
			Btn = bttn;

		}
		setBuzzerFreq(Btn, freqs[i]);
	}
    }
}
