package de.incircuit.demo.gpio;

import android.app.TabActivity;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.widget.TabHost;

public class mainActivity extends TabActivity {
	private static final String TAG = "mainActivity.java";
	private static final boolean DEBUG = false;
	private tabdesc tabs[] = {
			new tabdesc(this, "Klavier", klavierActivity.class),
			new tabdesc(this, "Gpio", gpioActivity.class),
			new tabdesc(this, "leds", "LEDs/Relais", ledActivity.class),
			new tabdesc(this, "ADC", adcActivity.class),
			new tabdesc(this, "CNT", cntActivity.class),
	};
	
	private class tabdesc {
		private String spec;
		private String indicator;
		private Class<?> cls;
		private mainActivity main;

		public tabdesc(mainActivity main, String spec, String indicator, Class<?> cls) {
			this.spec = spec;
			this.indicator = indicator;
			this.cls = cls;
			this.main = main;
		}

		public tabdesc(mainActivity main, String ind, Class<?> cls) {
			this(main, ind.toLowerCase(), ind, cls);
		}

		public void addTab(TabHost tabHost) {
			Intent intent = new Intent().setClass(main, this.cls);
			TabHost.TabSpec spec = tabHost.newTabSpec(this.spec).setIndicator(indicator).setContent(intent);
			tabHost.addTab(spec);
		}
	}
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);     
		if(DEBUG)
			Log.d(TAG, "Creating Tabs");

        TabHost tabHost = getTabHost();
        for(int i = 0; i< tabs.length; i++) {
        	tabs[i].addTab(tabHost);
        }
    }
}
