package de.incircuit.hw;

import android.util.Log;
import de.incircuit.hw.adbjni.ADBJni;

public class CNT {
	private static final String CNT_DIR = "/sys/bus/spi/devices/spi0.0/counter";
	private ADBJni hw;
	private static final String TAG = "CNT.java";
	private static final boolean DEBUG = true;
	private String path;
	
	public CNT(int num) {
		hw = new ADBJni();
		path = CNT_DIR + num;
		if(DEBUG) Log.d(TAG, "counter at"+path);
	}
	
	public int get() {
		if(DEBUG) 
			Log.d(TAG, "Reading counter");
		return hw.readIntegerFromFile(path);
	}
	
	public void add(int value) {
		if(DEBUG)
			Log.d(TAG, "Setting increment");
		hw.writeIntegerToFile(path, value);
	}
	
	public void reset() {
		if(DEBUG)
			Log.d(TAG, "Resetting Counter");
		hw.writeStringToFile(path, "reset");
	}
}
