package de.incircuit.hw;

import android.util.Log;
import de.incircuit.hw.adbjni.ADBJni;

public class GPIO {
	public static final boolean DEBUG = false;
	public static final String TAG = "GPIO.java";

	public static final String GPIO_DIR_OUT = "out";
	public static final String GPIO_DIR_IN = "in";

	public static final String GPIO_DIR = "/sys/class/gpio/";
	// public static final String GPIO_DIR = "/sdcard/gpio/";
	public static final String GPIO_DIRECTION_FILE = "direction";
	public static final String GPIO_VALUE_FILE = "value";

	private ADBJni hw;
	private int gpio = 0;

	public GPIO(int gpio) {
		if (DEBUG)
			Log.d(TAG, "GPIO(gpio=" + gpio + ")");

		hw = new ADBJni();
		this.gpio = gpio;
	}

	public GPIO(String gpio) {
		if (DEBUG)
			Log.d(TAG, "GPIO(gpio=" + gpio + ")");

		hw = new ADBJni();
		int gpio_num = 32;

		try {
			String port = gpio.substring(1, 2);
			int pin = Integer.parseInt(gpio.substring(2));
			if (port.contains("A")) {
				gpio_num = 32;
			} else if (port.contains("B")) {
				gpio_num = 64;
			} else if (port.contains("C")) {
				gpio_num = 96;
			} else if (port.contains("D")) {
				gpio_num = 128;
			}
			gpio_num += pin;
		} catch (NumberFormatException e) {
			Log.d(TAG, "NumberFormatException=" + e.toString()
					+ " set gpio_num=0");
			gpio_num = 0;
		}

		this.gpio = gpio_num;
		if (DEBUG)
			Log.d(TAG, "GPIONUM=" + this.gpio);
	}

	public String getDirection() {
		String dir = hw.readStringFromFile(GPIO_DIR + "gpio" + gpio + "/"
				+ GPIO_DIRECTION_FILE, 16);

		if (DEBUG)
			Log.d(TAG, "getDirection() dir=" + dir);

		if (dir == null)
			return "";
		if (dir.contains("in"))
			return "in";

		return "out";
	}

	public void setDirection(String dir) {
		if (DEBUG)
			Log.d(TAG, "setDirection(dir=" + dir + ")");

		hw.writeStringToFile(GPIO_DIR + "gpio" + gpio + "/"
				+ GPIO_DIRECTION_FILE, dir + "\n");
	}

	public void setValue(int value) {
		if (DEBUG)
			Log.d(TAG, "setValue(value=" + value + ")");

		hw.writeIntegerToFile(GPIO_DIR + "gpio" + gpio + "/" + GPIO_VALUE_FILE,
				value);
	}

	public int getValue() {
		if (DEBUG)
			Log.d(TAG, "getValue()");

		return hw.readIntegerFromFile(GPIO_DIR + "gpio" + gpio + "/"
				+ GPIO_VALUE_FILE);
	}
}
