package de.incircuit.hw;

import android.util.Log;
import de.incircuit.hw.adbjni.ADBJni;

public class LED {
	private static final boolean DEBUG = false;
	private static final String TAG = "LED.java";
	
	private ADBJni hw;
	private int num;
	private static final String LED_PATH = "/sys/class/leds/spi0.0:led";
	private static final String LED_FILE = "brightness";
	
	public LED(int num){
		if(DEBUG)
			Log.d(TAG, "LED(num="+num+")");
		
		hw = new ADBJni();
		this.num = num;
	}
	
	public void set(int value){
		if(DEBUG)
			Log.d(TAG, "set(value="+value+")");

		hw.writeIntegerToFile(LED_PATH+num+"/"+LED_FILE, value);
	}
	
	public int get(){
		if(DEBUG)
			Log.d(TAG, "get()");
		
		return hw.readIntegerFromFile(LED_PATH+num+"/"+LED_FILE);
	}
	
}
