package de.incircuit.hw.adbjni;

import android.util.Log;

public class ADBJni {

	private static final String TAG = "ADBJni.java";
	private static final boolean DEBUG = false;
	
	public native String writeStringToFile(String file, String value);

	public native String readStringFromFile(String file, int maxsize);

	public native int uart_open(String file, int baud);

	public native int uart_read(int uart, char[] buffer, int size);

	public native void uart_write(int uart, char[] buffer, int size);

	public native void uart_close(int uart);

	public int readIntegerFromFile(String file){
		if(DEBUG)
			Log.d(TAG, "readIntegerFromFile(file="+file+")");
		
		String str = readStringFromFile(file, 16);
		int ret;
		
		if(str == null)
			return -1;
		
		str = str.replace("\r", "");
		str = str.replace("\n", "");

		try{
			ret = Integer.parseInt(str);
		} catch(NumberFormatException e){
			Log.d(TAG, "NumberFormatException="+ e.toString());
			return -1;
		}
		
		if(DEBUG)
			Log.d(TAG, file+"="+ret);
		return ret;
	}
	
	public void writeIntegerToFile(String file, int value){
		if(DEBUG)
			Log.d(TAG, "writeIntegerToFile(file="+file+", value="+value+")");
		writeStringToFile(file, String.format("%d", value));
	}
	
	static {
		System.loadLibrary("adb-jni");
	}
}
